

#include <stdio.h>
#include <stdlib.h>
#include "../include/config.h"
#include "../include/ansix931.h"

void ahtopb (char *ascii_hex, BYTE *p_binary, int bin_len);
void printnum(char *S, BYTE *A, int L);

int main(int argc, char *argv[]) {
	BYTE K[16], V[8], DT[8], R[8];
        char roundString[16];
	int rounds, cntr;

	if(argc == 5) {

		ahtopb(argv[1], K, 8);
		ahtopb(argv[2], K+8, 8);
		ahtopb(argv[3], V, 8);
		ahtopb(argv[4], DT, 8);

		printnum("Key1 = ", K, 8);
		printnum("Key2 = ", K+8, 8);
		printnum("DT = ", DT, 8);
		printnum("V = ", V, 8);

		ANSIX931_init(K);
		ANSIX931(V, DT, R);

		printnum("R = ", R, 8);
	} else if(argc == 6) {
		ahtopb(argv[1], K, 8);
		ahtopb(argv[2], K+8, 8);
		ahtopb(argv[3], V, 8);
		ahtopb(argv[4], DT, 8);
		rounds = atoi(argv[5]);

		printnum("Key1 = ", K, 8);
		printnum("Key2 = ", K+8, 8);
		printnum("DT = ", DT, 8);
		printnum("V = ", V, 8);

		ANSIX931_init(K);
		for(cntr=0; cntr < rounds; cntr++) {
			ANSIX931(V, DT, R); 
                        /*sprintf(roundString, "V[%u] =", cntr);
                        printnum(roundString, V, 8);
                        sprintf(roundString, "DT[%u] =", cntr);
                        printnum(roundString, DT, 8);
                        sprintf(roundString, "R[%u] =", cntr);
                        printnum(roundString, R, 8);*/
		}

		printnum("R = ", R, 8);
	} else {
		printf("test931 K1 K2 V DT\n");
		printf("test931 K1 K2 V DT rounds\n");
		return 1;
	}
	return 0;
}

void ahtopb (char *ascii_hex, BYTE *p_binary, int bin_len)
{
	BYTE    wbyte, wbyte2;
	int     i; 
	
	for (i = 0; i < bin_len; i++) 
	{
        wbyte = ascii_hex[i * 2];
	    if (wbyte > 'F')
	        wbyte -= 0x20;   
	    if (wbyte > '9')
	        wbyte -= 7;      
	    wbyte -= '0';   
	    wbyte2 = wbyte << 4;

	    wbyte = ascii_hex[i * 2 + 1];
	    if (wbyte > 'F')
			wbyte -= 0x20;
        if (wbyte > '9')
            wbyte -= 7;   
        wbyte -= '0';
		wbyte2 += wbyte;

        p_binary[i] = wbyte2; 
	}
}

void printnum(char *S, BYTE *A, int L)
{
 int i;

 printf("%s",S);

  for (i=0;i < L/(signed int)sizeof(BYTE); i++) {
      printf("%02x",A[i]);
  }
  printf("\n");

}

