/*modified the LITTLE_ENDIAN and BIG_ENDIAN flags by prepending "STS_"
 *as LITTLE_ENDIAN and BIG_ENDIAN are defined constants on many machines*/
/*
 * config.h
 */

#ifndef __CONFIG_H
#define	__CONFIG_H

/*
 *  EDIT THE FOLLOWING DEFINE BEFORE COMPILING
 *  TO SET THE COMPILATION ENVIRONMENT.
 *   (Select: WINDOWS31, UNIX)
 */
#define	UNIX 1
/* #define	WINDOWS31 1 */

typedef unsigned char	BYTE;   /*8 bit unsigned*/
typedef unsigned int	UINT32; /*32 bit unsigned int*/
typedef unsigned short	DIGIT;	/* 16-bit word */
typedef unsigned long	ULONG;
typedef unsigned int	DBLWORD;  /* 32-bit word */
typedef unsigned int	UINT;

#ifdef UNIX

/* Manual Endianness selections*/
/*For LITTLE ENDIAN machines:*/
#undef	STS_BIG_ENDIAN
#ifndef STS_LITTLE_ENDIAN
#define	STS_LITTLE_ENDIAN
#endif

/*For BIG ENDIAN machines:*/
/*
#undef	STS_LITTLE_ENDIAN
#ifndef STS_BIG_ENDIAN
#define	STS_BIG_ENDIAN
#endif
*/

#ifndef STS_BIG_ENDIAN
#ifndef STS_LITTLE_ENDIAN
#error No endianness selection made. Edit config.h
#endif
#endif

#ifdef STS_BIG_ENDIAN
#ifdef STS_LITTLE_ENDIAN
#error Both STS_BIG_ENDIAN and STS_LITTLE_ENDIAN are defined.  Edit config.h
#endif
#endif

#undef	DEC  /*For the cephes library*/
#endif

#ifdef WINDOWS31
#define	LITTLE_ENDIAN
#endif

#endif
