#include <stdio.h>
#include <stdlib.h>

int main(int argc, char *argv[]) {
	int blockSize;
	char tempBlock[8];
	int inputChar;
	int blockPos = 0;
	int cntr;

	if(argc != 2) {
		fprintf(stderr, "little2big <block size>\n");
		fprintf(stderr, "Block sizes supported are 2, 4, 8\n");
		exit(1);
	}

	blockSize = atoi(argv[1]);

	if((blockSize != 2) && (blockSize != 4) && (blockSize != 8)) {
		fprintf(stderr, "little2big <block size>\n");
		fprintf(stderr, "Block sizes supported are 2, 4, 8\n");
		exit(1);
	}

	inputChar = fgetc(stdin);
	blockPos = blockSize;

	while(inputChar != EOF) {
		blockPos--;
		tempBlock[blockPos] = inputChar;

		if(blockPos == 0) {
		/*output the block*/
		for(cntr=0; cntr < blockSize; cntr++) 
			fputc(tempBlock[cntr], stdout);

		blockPos = blockSize;
		}

		inputChar = fgetc(stdin);
	}

	if(blockPos != blockSize)
		fprintf(stderr, "Incomplete final block of %d length\n", blockSize - blockPos);

	return(0);
}
