#!/usr/bin/perl

print "Start $ARGV[1] against $ARGV[0]\n";

open(RESULTFILE, "<$ARGV[0]") || die "Can't open $ARGV[0] for read";

#frequency
$ansline = <RESULTFILE>;
chomp $ansline;

$expans = &getResultLine($ARGV[1], "frequency", 1);
if($expans != $ansline) {
	$delta = $expans - $ansline;
	print "frequency mismatch of $delta\n";
	print "expected: $ansline  got: $expans \n";
}

#block frequency
$ansline = <RESULTFILE>;
chomp $ansline;

$expans = &getResultLine($ARGV[1], "block-frequency", 1);
if($expans != $ansline) {
	$delta = $expans - $ansline;
	print "Block Frequency mismatch of $delta\n";
	print "expected: $ansline  got: $expans \n";
}

#csum-forward
$ansline = <RESULTFILE>;
chomp $ansline;

$expans = &getResultLine($ARGV[1], "cumulative-sums", 1);
if($expans != $ansline) {
	$delta = $expans - $ansline;
	print "cusum-forward mismatch of $delta\n";
	print "expected: $ansline  got: $expans \n";
}

#csum-reverse
$ansline = <RESULTFILE>;
chomp $ansline;

$expans = &getResultLine($ARGV[1], "cumulative-sums", 2);
if($expans != $ansline) {
	$delta = $expans - $ansline;
	print "cusum-reverse mismatch of $delta\n";
	print "expected: $ansline  got: $expans \n";
}

#runs
$ansline = <RESULTFILE>;
chomp $ansline;

$expans = &getResultLine($ARGV[1], "runs", 1);
if($expans != $ansline) {
	$delta = $expans - $ansline;
	print "Runs mismatch of $delta\n";
	print "expected: $ansline  got: $expans \n";
}

#Long Runs of Ones
$ansline = <RESULTFILE>;
chomp $ansline;

$expans = &getResultLine($ARGV[1], "longest-run", 1);
if($expans != $ansline) {
	$delta = $expans - $ansline;
	print "Long Runs of ones mismatch of $delta\n";
	print "expected: $ansline  got: $expans \n";
}

#rank
$ansline = <RESULTFILE>;
chomp $ansline;

$expans = &getResultLine($ARGV[1], "rank", 1);
if($expans != $ansline) {
	$delta = $expans - $ansline;
	print "Rank mismatch of $delta\n";
	print "expected: $ansline  got: $expans \n";
}

#Spectral
$ansline = <RESULTFILE>;
chomp $ansline;

$expans = &getResultLine($ARGV[1], "fft", 1);
if($expans != $ansline) {
	$delta = $expans - $ansline;
	print "Spectral DFT mismatch of $delta\n";
	print "expected: $ansline  got: $expans \n";
}

#Non-overlapping Templates
$ansline = <RESULTFILE>;
chomp $ansline;

$expans = &getResultLine($ARGV[1], "nonperiodic-templates", 1);
if($expans != $ansline) {
	$delta = $expans - $ansline;
	print "Non-overlapping Templates mismatch of $delta\n";
	print "expected: $ansline  got: $expans \n";
}

#Overlapping Templates
$ansline = <RESULTFILE>;
chomp $ansline;

$expans = &getResultLine($ARGV[1], "overlapping-templates", 1);
if($expans != $ansline) {
	$delta = $expans - $ansline;
	print "Overlapping Templates mismatch of $delta\n";
	print "expected: $ansline  got: $expans \n";
}

#Universal
$ansline = <RESULTFILE>;
chomp $ansline;

$expans = &getResultLine($ARGV[1], "universal", 1);
if($expans != $ansline) {
	$delta = $expans - $ansline;
	print "Universal mismatch of $delta\n";
	print "expected: $ansline  got: $expans \n";
}

#apen
$ansline = <RESULTFILE>;
chomp $ansline;

$expans = &getResultLine($ARGV[1], "apen", 1);
if($expans != $ansline) {
	$delta = $expans - $ansline;
	print "Approximate Entropy mismatch of $delta\n";
	print "expected: $ansline  got: $expans \n";
}

#Random Excursions
$ansline = <RESULTFILE>;
chomp $ansline;

$expans = &getResultLine($ARGV[1], "random-excursions", 5);
if($expans != $ansline) {
	$delta = $expans - $ansline;
	print "Random Excursions mismatch of $delta\n";
	print "expected: $ansline  got: $expans \n";
}

#Random Excursions Variant
$ansline = <RESULTFILE>;
chomp $ansline;

$expans = &getResultLine($ARGV[1], "random-excursions-variant", 9);
if($expans != $ansline) {
	$delta = $expans - $ansline;
	print "Random Excursions Variant mismatch of $delta\n";
	print "expected: $ansline  got: $expans \n";
}

#Lempel Ziv Complexity
$ansline = <RESULTFILE>;
chomp $ansline;

$expans = &getResultLine($ARGV[1], "lempel-ziv", 1);
if($expans != $ansline) {
	$delta = $expans - $ansline;
	print "Lempel Ziv Complexity mismatch of $delta\n";
	print "expected: $ansline  got: $expans \n";
}

#Linear Complexity
$ansline = <RESULTFILE>;
chomp $ansline;

$expans = &getResultLine($ARGV[1], "linear-complexity", 1);
if($expans != $ansline) {
	$delta = $expans - $ansline;
	print "Linear Complexity mismatch of $delta\n";
	print "expected: $ansline  got: $expans \n";
}

#Serial
$ansline = <RESULTFILE>;
chomp $ansline;

$expans = &getResultLine($ARGV[1], "serial", 1);
if($expans != $ansline) {
	$delta = $expans - $ansline;
	print "Serial mismatch of $delta\n";
	print "expected: $ansline  got: $expans \n";
}


print "Done checking $ARGV[1] against $ARGV[0]\n";

sub getResultLine
{
        local($i, $curLine);
        local($basedir, $subdir, $line)=@_;

	open(DATAFILE, "<$basedir/$subdir/results") || 
		die "Can't open $basedir/$subdir/results for read";
	for($i = 0; $i < $line; $i++) {
		$curLine = <DATAFILE>;
	}

	close(DATAFILE);
	chomp $curLine;

	$curLine;
}


